//*****************************************************************************
//
//  For the latest version of this DLL, go to
//
//  http://www.geocities.com/uncle_gaga/rb_dll.html 
//  
//  Send comments and suggestion to uncle_gaga@geocities.com
//
//*****************************************************************************

//*****************************************************************************
#include <windows.h>
#include <string.h>
#include <ctype.h>
#include "exports.h"
#include "cwstart.h"

//*****************************************************************************
LIBMAIN

//*****************************************************************************
static LPSTR   _rb_line_comment = "#";
static LPVOID  _rb_hash_names[3] = {0};
static int     _rb_hash_sizes[3] = { 47, 47, 47 };
static LPVOID  _rb_hash_templates = NIL;

//*****************************************************************************
LPSTR rb_INDENT_STR = "\377def\377else\377for\377case\377when\377begin";

//*****************************************************************************
LPSTR _rb_names[] = 
{
"alias",  "and",   "BEGIN","begin","break", "case",   "class",  "def",   "defined",
"do",     "else",  "elsif","end",  "END",   "ensure", "false",  "for",   "if",     "in",
"module", "next",  "nil",  "not",  "or",    "redo",   "rescue", "retry", "return",
"self",   "super", "then", "true", "undef", "unless", "until",  "when",  "while",
"yield",  NIL
};

//*****************************************************************************
typedef struct _LanguageTemplate 
{         
    LPSTR strAbbrev;
    LPSTR strTemplate;
} 
LanguageTemplate;

//*****************************************************************************
LanguageTemplate _rb_templates[] = 
{
    { "BEG|BEGIN",         "BEGIN\n{\n\t&\n@}" },
    { "beg|begin",         "begin\n\t&\nrescue\n\nelse\n\nensure\n\n@end" },
    { "cas|case",          "case\n&\t\nwhen\n\nelse\n\n@end" },
    { "clas|class",        "class & <\n\t\n@end" },
    { "def",               "def &\n\t\n@end" },
    { "defi|defin|defined","defined? &" },
    { "do",                "do\n\t&\n@end" },
    { "END",               "END\n{\n\t&\n@}" },
    { "for",               "for & in  do\n\t\n@end" },
    { "mod|module",        "module &\n\t\n@end" },
    { "then",              "then\n\t&\n@end" },
    { "{",                 "{\n\t&\n@}" },
    { NIL, NIL },
};

//*****************************************************************************
static long _rb_in_comment( long lOffset );

//*****************************************************************************
void DLL _rb_init( void );
void DLL rbSetCommentChar( LPSTR str );
BOOL DLL _rb_expand( void );
long DLL _rb_language_colors_update( long lFirstline, long lLastline );
void DLL _rb_language_colors( long lNumlines );
void DLL _rb_assign_template( LPSTR strAbbrev, LPSTR strTemplate );
void DLL _rb_add_keyword( LPSTR strKeyword, int iTable );
BOOL DLL _rb_indent( void );
void DLL _rb_routines( void);
int  DLL _RubyErrorInfo( void );

//*****************************************************************************
PRIVATE void XNEAR _rb_languageColorRange( long startoff, long endoff );
PRIVATE BOOL isOperator( char c, char nextChar  );
PRIVATE BOOL isNumber( char c, char nextChar );
PRIVATE BOOL isStringDelimiter( char c );
PRIVATE BOOL isScopeDelimiter( char c );
PRIVATE void _rb_addOutlineParsers();
PRIVATE void _rb_addFilters();

//*****************************************************************************
void DLL _init()
{
    _rb_init();
    CompilerNewExt( ".rb" );
    ExtAlias(".ruby", ".rb");
}


//*****************************************************************************
void DLL rbSetCommentChar( LPSTR str )
{
    if( str && *str )
    {
        _rb_line_comment[0] = str[0];
    }
}

//*****************************************************************************
void DLL _rb_init( void )
{
    static BOOL bFirstTime = TRUE;

    int    i;
    LPSTR  str;

    if( bFirstTime )
    {
        bFirstTime = FALSE;

        LibExport( "BOOL _rb_expand" );
        LibExport( "_rb_assign_template LPSTR LPSTR" );
        LibExport( "BOOL _rb_indent" );
        LibExport( "long _rb_language_colors_update long long" );
        LibExport( "_rb_language_colors long" );
        LibExport( "rbSetCommentChar LPSTR" );
        LibExport( "_rb_add_keyword LPSTR int" );
        LibExport( "int _RubyErrorInfo " );
        LibExport( "_rb_routines" );

        for ( i = 0; (str = _rb_names[ i ]) != NIL; i++ )
        {
            __c_add_keyword( str, 0, _rb_hash_names, _rb_hash_sizes );
        }

        _rb_hash_templates = HashCreateTable( 17, sizeof( LPSTR ), 0 );

        for ( i = 0; (str = _rb_templates[ i ].strAbbrev ) != NIL; i++ )
        {
            _rb_assign_template( str, _rb_templates[i].strTemplate );
        }

        _AddErrorInfoName( "_RubyErrorInfo" );

        CompilerAddCmd( "ruby syntax checker", 
                "${FTEE} ruby -c %b%e", ERRCMD_SAVE|ERRCMD_CAPTURE_OUTPUT|ERRCMD_HANDLE_ERRORS,
                "${FTEE} ruby -c %b%e", ERRCMD_SAVE|ERRCMD_CAPTURE_OUTPUT|ERRCMD_HANDLE_ERRORS,
                NIL, ERRCMD_SAVEALL|ERRCMD_CAPTURE_OUTPUT,
                NIL, ERRCMD_SAVEALL|ERRCMD_CAPTURE_OUTPUT,
                NIL, 0,
                NIL, 0,
                "_RubyErrorInfo", NIL, NIL,
                NIL,
                NIL );

        _rb_addOutlineParsers();
        _rb_addFilters();

        ExtColorsAssoc(".rb", 1 );
        ExtIndentEnableAssoc( ".rb", 35 );
        ExtSetDelimiters( ".rb", "\^A\-Za\-z0\-9_" );

        ExtSetBorderElements( ".rb",
                              "#",
                              "#",
                              "#",
                              "#",
                              "#",
                              "#",
                              "#",
                              "#",
                              "#",
                              "#",
                              TRUE );

        ExtSetStyle( ".rb", 3 );

    }
}

//*****************************************************************************
PRIVATE void _rb_addOutlineParsers()
{
    DWORD dwParserFlags = PARSER_FLAG_ALPHA | PARSER_FLAG_NUMERIC | PARSER_FLAG_UNDERSCORE;

    ExtDelOutlineParser( ".rb" );

    ExtAddOutlineParser( ".rb", OUTLINE_TYPE_CLASS,     "class", dwParserFlags, "", "^[ \\t]*class[ \\t]+\\c[a-zA-Z0-9_]+[ \\t<\\n]+" );
    ExtAddOutlineParser( ".rb", OUTLINE_TYPE_FUNCTION,  "method",dwParserFlags, "", "^[ \\t]*def[ \\t]+\\c[a-zA-Z0-9_]+[ \\t\\n\\(]+" );
    ExtAddOutlineParser( ".rb", OUTLINE_TYPE_PROTOTYPE, "module",dwParserFlags, "", "^[ \\t]*module[ \\t]+\\c[a-zA-Z0-9_]+[ \\t\\n]+" );
}

//*****************************************************************************
PRIVATE void _rb_addFilters()
{
    FilterProjAdd( "ruby", "*.rb", 1 );
    FilterAdd( "ruby(*.rb)", "*.rb", 0 );

	FolderAdd( "ruby files", "*.rb" );
}

//*****************************************************************************
BOOL DLL _rb_expand( void )
{
    int    i = 0;

    LPVOID htEntry;
    LPSTR  _rb_string = NULL;
    LPSTR  str;

    MarkSavePos();

    if( _rb_in_comment( -1L ) != -1 )
    {
        goto _rb_expand_incomplete;
    }

    str = BufReadStr( 65535 );
    while( str[i] && !isspace(str[i]) )
    {
        i++;
    }

    str[i] = '\0';

    _rb_string = StrTrim( str, " \t" );
    StrFree( str );


    if( !_rb_string )
    {
        goto _rb_expand_incomplete;
    }

    htEntry = HashFindEntry( _rb_hash_templates, _rb_string, strlen( _rb_string ) );

    StrFree( _rb_string );

    if( htEntry )
    {
        MarkDropPos( 1 );
        str = *(LPSTR*)htEntry;
        BufDelToEOL();

        _ext_expand_template( str );

    } 
    else
    {
        goto _rb_expand_incomplete;
    }

    return TRUE;

_rb_expand_incomplete:

    MarkRestorePos();

    return FALSE;
}

//*****************************************************************************
long DLL _rb_language_colors_update( long lFirstline, long lLastline )
{
    long lStartoff = 0L;
    long lCount = 0L;

    if( lFirstline > 0 && lLastline > 0 && lLastline >= lFirstline )
    {
        _PosInit( 0 );
        
        if( lFirstline == 1L )
        {
            _PosPrevLine( 0L );
        }
        else
        {
            _PosNextLine( lFirstline - 1L );
        }

        lStartoff = _PosQOffset();

        AttrSetColor( lFirstline, lLastline, 1L, 0x7FFFFFFFL, 0 );

        _PosInit( lStartoff );

        _rb_language_colors( lLastline - lFirstline + 1L );
    }

    lCount = lLastline - lFirstline;

    return( lCount );
}
                    
//*****************************************************************************
void DLL _rb_language_colors( long lNumlines )
{
    long lStartoff;
    long lEndoff;

    if( lNumlines == -1L )
    {
        lStartoff = 0L;
        lEndoff = 0x7FFFFFFF;
    }
    else
    {
        lStartoff = _PosQOffset();
        _PosNextLine( lNumlines );
        lEndoff = _PosQOffset();
    }

    if( lStartoff < lEndoff )
    {
        _rb_languageColorRange( lStartoff, lEndoff );
    }
}

//*****************************************************************************
PRIVATE BOOL isNumber( char cChar, char cNextChar )
{
    if( cChar == '.' && cNextChar == '.' )
    {
        return FALSE;
    }
    return isdigit( cChar );
}

//*****************************************************************************
PRIVATE BOOL isOperator( char cChar, char cNextChar )
{
    if( cChar == '.' && cNextChar == '.' )
    {
        return TRUE;
    }
    return ( strchr( ".=+-*/%<>!&|?^~:,[]", cChar ) != 0 );
}

//*****************************************************************************
PRIVATE BOOL isStringDelimiter( char cChar )
{
    return ( cChar == '"' || cChar == '\'' );
}

//*****************************************************************************
PRIVATE BOOL isScopeDelimiter( char cChar )
{
    return ( strchr( "{}()", cChar ) != 0 );
}

//*****************************************************************************
PRIVATE void XNEAR _rb_languageColorRange( long lStartoff, long lEndoff )
{
    BOOL bInCommentFlag  = FALSE;
    BOOL bInStringFlag   = FALSE;
    BOOL bInBlockFlag    = FALSE;
    BOOL bInRegExpFlag   = FALSE;
    BOOL bSingleQuote    = FALSE;

    char ch;
    char previousCh = '\0';

    UINT comment_color  = ColorComments( -1 );
    UINT keyword_color  = ColorKeywords( -1 );
    UINT quote_color    = ColorAlternate1( -1 );
    UINT number_color   = ColorAlternate2( -1 );
    UINT brace_color    = ColorAlternate3( -1 );

    //int    function_color = ColorAlternate7( -1 );
    UINT  operator_color = ColorAlternate8( -1 );

    _PosInit( lStartoff );

    ch = (char)_PosCurrentChar();

    while( ( ch != EOF_CHAR ) && ( lStartoff < lEndoff ) )
    {
        if(     bInStringFlag  == FALSE 
             && bInCommentFlag == FALSE 
             && ch == '/'
             && previousCh != '\\' )
        {

            _PosSetColor( operator_color, 1 );
            bInRegExpFlag = !bInRegExpFlag;
        }
        else if( bInStringFlag == FALSE && ch == '#' )
        {
            bInCommentFlag = TRUE;
            _PosSetColor( comment_color, 1 );
            lStartoff++;
            previousCh = ch;
            ch = (char)_PosNextChar();
            continue;
        }
        else if( bInStringFlag == FALSE && ch == '\n' )
        {
            bInCommentFlag = FALSE;
            lStartoff++;
            previousCh = ch;
            ch = (char)_PosNextChar();
            continue;
        }
        else if(    bInStringFlag  == FALSE 
                 && bInCommentFlag == FALSE 
                 && bInRegExpFlag  == FALSE 
                 && previousCh != '$' 
                 && ch == ';' )
        {
            _PosSetColor( brace_color, 1 );
            lStartoff++;
            previousCh = ch;
            ch = (char)_PosNextChar();
            continue;
        }
        else if(    bInStringFlag  == FALSE 
                 && bInCommentFlag == FALSE 
                 && bInRegExpFlag  == FALSE 
                 && ch == '{' )
        {
            bInBlockFlag = TRUE;
            _PosSetColor( brace_color, 1 );
            lStartoff++;
            previousCh = ch;
            ch = (char)_PosNextChar();
            continue;
        }
        else if(    bInStringFlag  == FALSE 
                 && bInRegExpFlag  == FALSE 
                 && bInCommentFlag == FALSE 
                 && ch == '}' )
        {
            bInBlockFlag = FALSE;
            _PosSetColor( brace_color, 1 );
            lStartoff++;
            previousCh = ch;
            ch = (char)_PosNextChar();
            continue;
        }
        else if(    bInCommentFlag == FALSE 
                 && bInRegExpFlag  == FALSE 
                 && isStringDelimiter( ch )
                 && previousCh != '\\' )
        {
            BOOL bApplyStringColor = TRUE;
            if( bInStringFlag )
            {
                if( ch == '\'' && bSingleQuote )
                {
                    bInStringFlag = FALSE;
                }
                else if( ch == '"' && !bSingleQuote )
                {
                    bInStringFlag = FALSE;
                }
            }
            else
            {
                bSingleQuote = ( ch == '\'' );
                bApplyStringColor = bInStringFlag = ( previousCh != '$' );
            }

            if( bApplyStringColor )
            {
                _PosSetColor( quote_color, 1 );
                lStartoff++;
                previousCh = ch;
                ch = (char)_PosNextChar();
                continue;
            }
        }
        else if(    bInStringFlag  == FALSE 
                 && bInCommentFlag == FALSE 
                 && bInRegExpFlag  == FALSE 
                 && previousCh != '$'
                 && previousCh != '\\'
                 && isdigit( ch ) )
        {
            int  i = 0;
            long lStartName = lStartoff;

            char acName[ 1024 ];
            char cNextChar;

            memset( acName, 0, 1024 );

            acName[i++] = ch;

            cNextChar = (char)_PosNextChar();
            ch = (char)_PosPrevChar();

            while( ( i < 1024 ) && ( ch != EOF_CHAR )
                   && isNumber( ch, cNextChar ) 
                   && ( lStartoff < lEndoff ) )
            {
                ch = (char)_PosNextChar();
                acName[i++] = ch;

                cNextChar = (char)_PosNextChar();
                ch = (char)_PosPrevChar();

                lStartoff++;
            }

            _PosInit( lStartName );
            _PosSetColor( number_color, max( 1, lStartoff - lStartName ) );
            _PosInit( lStartoff );
        }
        else if(    bInStringFlag  == FALSE 
                 && bInRegExpFlag  == FALSE 
                 && bInCommentFlag == FALSE 
                 && !isOperator( ch, '\0' ) 
                 && ( isalnum( ch ) || (ch == '_') ) )
        {
			int iLen;
            int i = 0;
            int iColor = 0;

            long lStartName = lStartoff;

            char acName[ 1024 ];
            char cNextChar;

            memset( acName, 0, 1024 );

            acName[i++] = ch;
            cNextChar = (char)_PosNextChar();
            ch = (char)_PosPrevChar();

			while(     ( i < 1024 ) 
                 && ( lStartoff < lEndoff )
                 && ( ch != EOF_CHAR ) && (isalnum( ch ) || (ch == '_') ) )
            {
                ch = (char)_PosNextChar();
                acName[i++] = ch;

                cNextChar = (char)_PosNextChar();
                ch = (char)_PosPrevChar();

                lStartoff++;
            }

            iLen = strlen( acName );

            if( _rb_hash_names[1] && HashFindEntry( _rb_hash_names[1], acName, iLen - 1 ) )
            {
                iColor = ColorAlternate5( -1 );
            }
            else if( _rb_hash_names[2] && HashFindEntry( _rb_hash_names[2], acName, iLen - 1 ) )
            {
                iColor = ColorAlternate6( -1 );
            }
            else if( HashFindEntry( _rb_hash_names[0], acName, iLen - 1 ) )
            {
                iColor = keyword_color;
            }

            _PosInit( lStartName );
            _PosSetColor( iColor, iLen );
            _PosInit( lStartoff );
        }

        if( bInRegExpFlag  == FALSE )
        {
            if( bInCommentFlag )
            {
                _PosSetColor( comment_color, 1 );
            }
            else if( bInStringFlag )
            {
                _PosSetColor( quote_color, 1 );
            }
            else if( previousCh != '$' && isOperator( ch, '\0' ) )
            {
                _PosSetColor( operator_color, 1 );
            }
			else if( strchr( "{};", ch ) )
			{
				_PosSetColor( brace_color, 1 );
			}
			else if( isScopeDelimiter( ch ) )
			{
				_PosSetColor( 0, 1 );
         }
			else if( ch == '#' )
			{
				bInCommentFlag = TRUE;
				_PosSetColor( comment_color, 1 );
			}
        }

		previousCh = ch;
		ch = (char)_PosNextChar();

		lStartoff++;
    }
}

//*****************************************************************************
void DLL _rb_add_keyword( LPSTR strKeyword, int iTable )
{
    __c_add_keyword( strKeyword, iTable, _rb_hash_names, _rb_hash_sizes );
}

//*****************************************************************************
void DLL _rb_assign_template( LPSTR strAbbrev, LPSTR strTemplate )
{
    _ext_assign_template( _rb_hash_templates, strAbbrev, strTemplate );
}

//*****************************************************************************
BOOL DLL _rb_indent( void )
{
    long   lCurline;
    long   lCol;
    long   lMatchpos;

    LPSTR  _rb_string;
    LPSTR  str;

    MarkSavePos();

    lCurline = BufQCurrentLine();

    if(_rb_in_comment( -1L ) != -1)
    {
        goto _rb_indent_incomplete;
    }

    if( !SrchFind( "^[ \t]*[a-zA-Z_]+\\c([ \t]|$)", SEARCH_REGEX , NIL )
            || (BufQCurrentLine() != lCurline ) )
    {
        goto _rb_indent_incomplete;
    }

    lCol = BufQCurrentCol();

    SrchFind( "(^|[^a-zA-Z_])\\c[a-zA-Z_]", SEARCH_REGEX , NIL );

    str = BufReadStr( lCol - BufQCurrentCol() );

    _rb_string = StrTrim( str, " \t" );

    StrFree( str );

    str = StrNew( "\377" );

    _rb_string = StrAppend( _rb_string, str );

    str = StrAppend( str, _rb_string );

    StrFree( _rb_string );
    
    lMatchpos = StrMatch( str, rb_INDENT_STR, SEARCH_IGCASE | SEARCH_FORWARD, NIL );

    StrFree( str );

    if( !lMatchpos )
    {
        goto _rb_indent_incomplete;
    }
        
    MarkRestorePos();

    _ext_insert_indented_EOL();
    BufInsertChar( '\t' );
    
    return TRUE;

    _rb_indent_incomplete:
    
    MarkRestorePos();

    return FALSE;
}

//*****************************************************************************
void DLL _rb_routines( void )
{
    int   iMatches = 0;
    
    long  lDefline;

    LPSTR strDef = "([ \t]|^)(class|def|module)[ \t]";

    SysWaitStart();

    MarkSavePos();

    BufSetAscii();
    MovTopBuf();

    while( SrchFind( strDef, SEARCH_REGEX | SEARCH_FORWARD, 0 ))
    {
        lDefline = BufQCurrentLine();

        if( !iMatches )
        {
            AttrSetVisible( 0, 0, 0 );
        }
        
        iMatches++;

        AttrSetVisible( lDefline, lDefline, 1 );
        
        MovHome();

        if( !MovDown( 1 ) )
        {
            break; 
        }
    }

    if( iMatches )
    {
        BufSetCompact();
        MarkDropPos( 1 );
        MovTopBuf();
    }
    else
    {
        MarkRestorePos();
    }

    SysWaitEnd();
}

//*****************************************************************************
static long _rb_in_comment( long lOffset )
{
    WORD  ch;

    _PosInit( lOffset );

    ch = (char)_PosCurrentChar();

    do
    {
        if( ch == '\n' )
        {
            return -1;
        }
        else if( ch == (WORD)*_rb_line_comment )
        {
            return _PosQOffset();
        }
        
        ch = (char)_PosPrevChar();
    } 
    while( ch != EOF_CHAR  && _PosQOffset() );

    return -1L;
}

//*****************************************************************************
int DLL _RubyErrorInfo( void )
{
    int   i;
    int   iIndex=0;

    LONG  lPos;

    char  acErrorLine[10];

    LPSTR strSrch = ":\\c[0-9]+:";
    LPSTR strSrcName;
    LPSTR strMsg;

    if( !SrchFind( strSrch, SEARCH_FORWARD | SEARCH_REGEX | SEARCH_IGCASE, NIL ) )
    {
        return 0;
    }

    MarkSavePos();
    MovHome();
    
    strMsg = BufReadStr( 0x7FFFFFFF );
    
    MarkRestorePos();

    lPos = StrMatch( strSrch, strMsg, SEARCH_FORWARD | SEARCH_REGEX, NULL );

    ErrorSrcFile( strSrcName = StrSubStr( strMsg, (int)1, (int)lPos-2 ) );

    StrFree( strSrcName );

    for( lPos = 2, i = 0; i < 2; i++ )
    {
        BYTE c;
        while( (c = (BYTE)strMsg[lPos]) != '\0' )
        {
            lPos++;
            if( c == ':' )
            {
                break;
            }
        }
    }

    ErrorMsgLine( strMsg + lPos );

    StrFree( strMsg );

    strMsg = BufReadStr( 10 );

    memset( acErrorLine, 0, 10 );

    while( strMsg[iIndex] && strMsg[iIndex] != ':' )
    {
        acErrorLine[iIndex] = strMsg[iIndex];
        iIndex++;
    }

    ErrorLine( atol( acErrorLine ) );

    SrchFind( ",\\c", SEARCH_FORWARD | SEARCH_REGEX, NULL );

    StrFree( strMsg );
    
    return 2;
}
